function [wav, fs, fp, fn] = get_wav
% [wav, fs, fp, fn] = get_wav;
% opens a file selection dialog and returns:
% wav ... column vector ... samples of first channel of soundfile
% fs .... sampling rate
% fp .... path of the *.wav file
% fn .... name of the *.wav file
%
% C.Feldbauer 2000-2008, feldbauer@tugraz.at





[fn, fp] = uigetfile( '*.wav', 'Select a soundfile to open');
% obsolete???
% use my own instead:
%[fn, fp] =  myuigetfile( './', '*.wav');




%full = strcat( fp, fn);
full = fullfile( fp, fn);

[wav, fs] = audioread( full);
wsize = size( wav);
if wsize(2) ~= 1
   w( 1 : wsize(1)) = wav( 1 : wsize(1), 1);
   wav = w(:);
else
   wav = wav(:);
end
