% lpc_noise.m
% LPC -- noise excitataion only
% 2001--2002 by Christian Feldbauer
% feldbauer@tugraz.at


N = 256; % window length (even)
H = N/2; % hop size
O = 16;  % order of polynom


[wav, fs, fp, fn] = get_wav;
% wav ... column vector ... samples of one channel of soundfile

L = length( wav);

w = sqrt( hanning( N)); % window

NF = floor( (L-N)/H) +1; % number of frames

% preallocate memory for synthesized sound to speedup loop:
z = zeros( NF*H+N, 1);

for k = 0:NF-1 % frame-by-frame
  % analysis...
  x = wav( 1 + k*H : N + k*H); % windowing a segment
  x = x .* w;
  
  [a, g] = lpc( x, O); % lpc analysis
  
  
  % synthesis...
  noise = randn( N, 1); % white noise excitation
  
  y = filter( sqrt(g), a, noise); % filter
  y = y .* w; % synthesis window
  
  z( k*H + 1 : k*H + N) = z( k*H + 1 : k*H + N) + y; % overlap and add
end

z = z * 0.99 / max( abs(z)); % normalize output

% play output using sound(z,fs)
