% lpc_noise_dur.m
% LPC -- noise excitataion only
% can perform a time-scale modification
% 2002 by Christian Feldbauer
% feldbauer@tugraz.at


N = 256; % window length (even)
Ha = N/4; % frame hop size of analysis
TSM = 2; % time-scale modification factor

Hs = round( TSM*Ha); % frame hop size of synthesis

O = 16; % order of polynomial


[wav, fs, fp, fn] = get_wav;
% wav ... column vector ... samples of one channel of soundfile

L = length( wav);

w = sqrt( hanning( N)); % window

NF = floor( (L-N)/Ha) +1; % number of frames

% preallocate memory for synthesized sound to speedup loop:
z = zeros( NF*Hs+N, 1);

for k = 0:NF-1 % frame-by-frame
  % analysis...
  x = wav( 1 + k*Ha : N + k*Ha); % windowing a segment
  x = x .* w;
  
  [a, g] = lpc( x, O); % lpc analysis
  
  
  % synthesis...
  noise = randn( N, 1); % white noise excitation
  
  y = filter( sqrt(g), a, noise); % filter
  y = y .* w; % synthesis window
  
  z( k*Hs + 1 : k*Hs + N) = z( k*Hs + 1 : k*Hs + N) + y; % overlap and add
end

z = z * 0.99 / max( abs(z)); % normalize output

% play output using sound(z,fs)
